//
//  MPS - Maximum profit system
//

#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property show_inputs

#include <lib.mqh>

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+

//     
//      

extern double _profit = 0.01;
extern datetime _start = D'01.01.2008';
extern datetime _end = D'01.06.2008';
extern int _type = 1; //1 - long, 2 - short
extern string _file = "outdata.csv";
extern int MA_period = 14;
extern int _indicator = 1;
   //0   - MA   MODE_SMA
   //1   - MA   MODE_EMA
   //2   - MA   MODE_SMMA
   //3   - MA   MODE_LWMA
   
double short[]; 

int start() {
   int err,res;
   int i_index,s_index,k_index;
   int operation = 0; // 0 -  , 2 - , 1 - 
   datetime opentime, closetime;
   double profit = 0.0, total_profit = 0.0;
   string name_obj;
   
   int obj_total=ObjectsTotal();

   if (obj_total != 0) {
       ObjectsDeleteAll();
   }

   ArrayResize(short, Bars);
   
   for (i_index=0;i_index <= Bars-1;i_index++) {

   if (_type == 1) {
      if ((Close[i_index] > Open[i_index]) && (operation == 0)) {
         closetime = Time[i_index];
         opentime = NULL;         
         profit = Close[i_index] - Open[i_index];
         s_index = i_index;
         operation = 1;
      }
      if ((Close[i_index] > Open[i_index]) && (operation == 1)) {
         profit += Close[i_index] - Open[i_index];         
      }
      if ((Close[i_index] < Open[i_index]) && (operation == 1)) {
         opentime = Time[i_index-1];         
         operation = 0;
         if (closetime == opentime) {
            continue;            
         }
         if (profit > _profit) {
            total_profit += profit;
            name_obj = i_index;            
            short[s_index-1] = 1.0;
            short[i_index] = 0.5;
            for (k_index = s_index;k_index<i_index;k_index++) {
               short[k_index] = 0.8;
            }
            if(ObjectCreate("long_"+name_obj, OBJ_ARROW, 0, Time[i_index-1], Low[i_index-1])) {
               ObjectSet("long_"+name_obj, OBJPROP_ARROWCODE, 241);
               ObjectSet("long_"+name_obj, OBJPROP_COLOR, Red);               
            } else {
               err=GetLastError();
               Print("error: can't create text_object!",ErrorDescription(err));
               return(0);
            }
            name_obj = s_index;
            if(ObjectCreate("long_"+name_obj, OBJ_ARROW, 0, Time[s_index-1], High[s_index-1])) {
               ObjectSet("long_"+name_obj, OBJPROP_ARROWCODE, 251);
               ObjectSet("long_"+name_obj, OBJPROP_COLOR, Red);                              
            } else {
               err=GetLastError();
               Print("error: can't create text_object!",ErrorDescription(err));
               return(0);
            }
         }
      }
   }
   if (_type == 2) {
      if ((Close[i_index] < Open[i_index]) && (operation == 0)) {
         closetime = Time[i_index];
         opentime = NULL;         
         profit = Open[i_index] - Close[i_index];
         s_index = i_index;
         operation = 2;
      }
      if ((Close[i_index] < Open[i_index]) && (operation == 2)) {
         profit += Open[i_index] - Close[i_index];
      }
      if ((Close[i_index] > Open[i_index]) && (operation == 2)) {
         opentime = Time[i_index-1];         
         operation = 0;
         if (closetime == opentime) {
            continue;            
         }
         if (profit > _profit) {
            total_profit += profit;                  
            name_obj = i_index;            

            short[s_index-1] = 1.0;
            short[i_index] = 0.5;
            
            for (k_index = s_index;k_index<i_index;k_index++) {
               short[k_index] = 0.8;
            }

            if(ObjectCreate("short_"+name_obj, OBJ_ARROW, 0, Time[i_index-1], High[i_index-1])) {
               ObjectSet("short_"+name_obj, OBJPROP_ARROWCODE, 242);
               ObjectSet("short_"+name_obj, OBJPROP_COLOR, Blue);
            } else {
               err=GetLastError();
               Print("error: can't create text_object!",ErrorDescription(err));
               return(0);
            }
            name_obj = s_index;
            if(ObjectCreate("short_"+name_obj, OBJ_ARROW, 0, Time[s_index-1], Low[s_index])) {
               ObjectSet("short_"+name_obj, OBJPROP_ARROWCODE, 251);
               ObjectSet("short_"+name_obj, OBJPROP_COLOR, Blue);                              
            } else {
               err=GetLastError();
               Print("error: can't create text_object!",ErrorDescription(err));
               return(0);
            }
         }
      }
   }}

  int handle=FileOpen(_file, FILE_CSV|FILE_WRITE, ';');

  if(handle>0)
    {
      FileWrite(handle, "Id,Time","Out","Close","Open","MA(14,0)");
      double _res;
      for (i_index=Bars-MA_period-1;i_index >= 0;i_index--) {
         switch (_indicator) {
         case 0:
            _res = iMA(NULL,0,MA_period,0,MODE_SMA,PRICE_MEDIAN,i_index);
         case 1:
            _res = iMA(NULL,0,MA_period,0,MODE_EMA,PRICE_MEDIAN,i_index);
         case 2:
            _res = iMA(NULL,0,MA_period,0,MODE_SMMA,PRICE_MEDIAN,i_index);
         case 3:
            _res = iMA(NULL,0,MA_period,0,MODE_LWMA,PRICE_MEDIAN,i_index);
         
         
         }
         FileWrite(handle, Bars-i_index-MA_period,TimeToStr(Time[i_index]),DoubleToStr(short[i_index],1),DoubleToStr(Close[i_index],4),DoubleToStr(Open[i_index],4),DoubleToStr(_res,4));
      }
     FileClose(handle);
    }

   return(0);
}
//+------------------------------------------------------------------+